
/**************************************************
 * Footsteps Script
 *
 * User changeable stuff below
 **************************************************/

// Make sure the location of the footsteps .wav is in the same directory as
// this javascript file :)

// ***** Your 2 footsteps *******
footsteps = Sound("./footsteps.wav");    // Left foot
footsteps1 = Sound("./footsteps1.wav");  // Right foot

// ***** The footstep sounds other people make in the world 
otherfootsteps = Sound("./footsteps.wav"); // Both left and right foot

// ***** The feet ;) ************
numberfootsteps = 10;
leftfootfile = "./leftfoot.aer";
rightfootfile = "./rightfoot.aer";

// You may need to configure the footstep height to the height of your floor
// The footstep script attempts to calculate the location of your avatar feet
// But if this fails, you are able to force a certain footstepheight
// Line 101 sets the footstepheight - you can redfined it here :)


/***************************************************************************************/
footsteps.repeats = 1;
footsteps.volume = 0.6;
footsteps.far = 30;
footsteps.near = 3;
footsteps1.repeats = 1;
footsteps1.volume = 0.6;
footsteps1.far = 30;
footsteps1.near = 3;
otherfootsteps.repeats = 1;
otherfootsteps.volume = 0.8;
otherfootsteps.far = 30;
otherfootsteps.near = 5;


// Load up the footstep models. Left and right foot models
leftfootarr = Array(numberfootsteps);
rightfootarr = Array(numberfootsteps);
for(i=0;i<numberfootsteps; i++) {
	leftfootarr[i] = Model(leftfootfile).add();
	leftfootarr[i].visible = false;
	rightfootarr[i] = Model(rightfootfile).add();
	rightfootarr[i].visible = false;
}
ind = 0;

// Toggle button for synchronising your footstep sounds
synchfootsteps = Toggle("Let others hear your footsteps").add();
synchfootsteps.enabled = true;
synchfootsteps.state = false;

rand = new Date().getTime();
diff = 3.6;
av = undefined;

// We attempt to get the footstep height here
avmonitor = Object();
avmonitor.timestep = function() {
	if(player.avatarURL!=undefined && av==undefined) {
		// user avatar has loaded... strangely enough, we want to load it again
		// to get location of the foot...
		av = Model(player.avatarURL);
		av.position = player.position;
		av.visible = false;
		av.add();
	}
	if(av!=undefined && av.loaded) {
		diff = Math.abs(av.bounds[1].y-av.bounds[0].y);
		removeAnimator(this);
	}
}
addAnimator(avmonitor);


// The main footstep timestep function
footstepcheck = Object();
footstepcheck.thetime = 0.4;
footstepcheck.alt = true;
footstepcheck.playerspeed = player.forwardSpeed;
footstepcheck.timestep = function(tot, now) {
	player.keyUpDownMovesEnabled = false;
	if(application.upArrowKeyDown || application.downArrowKeyDown) {
		this.thetime +=now;
		this.footstepcheck = Math.abs(player.forwardSpeed);
		if(this.footstepcheck > 80) this.footstepcheck = 80;
		this.dofoot = (1.0-this.footstepcheck/80.0)*0.6;
		if(this.thetime>= this.dofoot) {
			if(ind==numberfootsteps) ind = 0;
			if(av!=undefined) av.position = player.position;
		
// The footstep height is set here. If this needs to be specifically defined
// then change this next line. 
			footstepheight = player.position.y - diff + 0.5;
		
			rot = player.transform.rotation.toString();
			rot = Rotation('R(0,'+rot.substring(rot.indexOf(",")+1, rot.lastIndexOf(","))+',0)');
			
			thefoot = undefined;
			if(this.alt) {
				thefoot = leftfootarr[ind];
				footsteps.play();
				this.alt = false;
			} else {
				thefoot = rightfootarr[ind];
				footsteps1.play();
				ind++;
				this.alt = true;
			}
			if(thefoot.sobj==undefined) thefoot.sobj = thefoot.getSolidObject(0);
			thefoot.visible = true;
			thefoot.orientation = rot;
			thefoot.position = [player.position.x, footstepheight, player.position.z];
			thefoot.sobj.opacity = 1;

			this.thetime = 0;
			
			if(synchfootsteps.state) {
				chat.input(player.position.x+"|"+player.position.y+"|"+player.position.z+"|"+rand+"||");			
			}
		}
	} else {
		this.thetime = 0.4;	
	}

	// Check footstep fade.. 
	for(i=0; i<numberfootsteps; i++) {
		if(leftfootarr[i].visible) {
			leftfootarr[i].sobj.opacity -= 0.001;
			if(leftfootarr[i].sobj.opacity==0)  leftfootarr[i].visible = false;
		}
		if(rightfootarr[i].visible) {
			rightfootarr[i].sobj.opacity -= 0.001;		
			if(rightfootarr[i].sobj.opacity==0) rightfootarr[i].visible = false;
		}
	}
}
addAnimator(footstepcheck);


chat.filterOutput = function(msg) {
	var index = msg.indexOf("||");
	if(index==-1) {
		return msg;
	} else {
		detail = msg.substring(0, index);
		msg = msg.substring(index+2);	

		arr = detail.split("|");
		dist = Math.sqrt(Math.pow(player.position.x-eval(arr[0]),2)+Math.pow(player.position.y-eval(arr[1]),2)+Math.pow(player.position.z-eval(arr[2]), 2));
		if(rand!=eval(arr[3]) && dist < 30) {		
			otherfootsteps.position = [eval(arr[0]),eval(arr[1]),eval(arr[2]) ];
			otherfootsteps.play();
		}
		if(msg.length>0) {
			return msg;
		}
		return "";		
	}
}
